//////////////////////////////////////////////////////////
/********************************************************/
/*                                                      */
/*  Fachhochschule Jena                                 */
/*  Mikroprozessortechnik                               */
/*  Michael Goldbuch; Jrgen Dffinger                  */
/*                                                      */
/*  motor.asm   Version 1.0.0   2011-05-19              */
/*                                                      */
/*  Die motor.asm enthlt alle Funktionen zur Steuerung */
/*  der Motoren des ASUROs.                             */
/*                                                      */
/********************************************************/
//////////////////////////////////////////////////////////



/***************   PWM_INIT   ***************/

PWM_INIT:

	push R16

	; for PWM (8-Bit PWM) on OC1A & OC1B
	ldi R16, (1 << WGM10) | (1 << COM1A1) | (1 << COM1B1)
	out TCCR1A, R16
	ldi R16, (1 << CS11)
	out TCCR1B, R16

	pop  R16

ret



/***************   motorspeed   ***************/

.macro motorspeed
	
	//	Register sichern
	push R17
	push R18

	//	Register initialisieren
	ldi  R17,@0
	ldi  R18,@1

	//	Motorgeschwindigkeit ber mspeed einstellen
	rcall mspeed

	//	Register wiederherstellen
	pop  R18
	pop  R17

.endm

mspeed:
	
	//	Register sichern
    push R16

	//	Timer 1 fr OC1A und OC1B setzen (Pulsweite und Pulspause fr PWM)
	clr R16
	out OCR1AH, R16
	out OCR1AL, R17
	out OCR1BH, R16
	out OCR1BL, R18

	//	Register wiederherstellen
	pop R16

ret



/***************   MotorDir_FWD_FWD   ***************/


MotorDir_FWD_FWD:
	
	//	left and right engine forward

	sbi PORTD,5
	cbi PORTD,4
	sbi PORTB,5
	cbi PORTB,4

ret



/***************   MotorDir_FWD_RWD   ***************/


MotorDir_FWD_RWD:
	
	

	sbi PORTD,5
	cbi PORTD,4
	cbi PORTB,5
	sbi PORTB,4

ret



/***************   MotorDir_RWD_FWD   ***************/


MotorDir_RWD_FWD:
	
	

	cbi PORTD,5
	sbi PORTD,4
	sbi PORTB,5
	cbi PORTB,4

ret



/***************   MotorDir_RWD_RWD   ***************/

MotorDir_RWD_RWD:

	//	left and right engine reward
	cbi PORTD,5
	sbi PORTD,4
	cbi PORTB,5
	sbi PORTB,4

ret



/***************   Motor_Stop   ***************/

Motor_Stop:
	motorspeed 0x00,0x00
ret







